package com.goafanti.common.dao;

import com.goafanti.common.model.TChangeTask;
import com.goafanti.order.bo.TChangeTaskOut;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 变更任务表(TChangeTask)表数据库访问层
 *
 * @author makejava
 * @since 2025-01-07 10:29:38
 */
public interface TChangeTaskMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    TChangeTask selectById(Integer id);

    

    /**
     * 查询指定行数据
     *
     * @param tChangeTask 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<TChangeTask> findTChangeTaskList(TChangeTask tChangeTask, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param tChangeTask 查询条件
     * @return 总行数
     */
    int findTChangeTaskCount(TChangeTask tChangeTask);

    /**
     * 新增数据
     *
     * @param tChangeTask 实例对象
     * @return 影响行数
     */
    int insert(TChangeTask tChangeTask);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<TChangeTask> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<TChangeTask> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<TChangeTask> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<TChangeTask> entities);

    /**
     * 修改数据
     *
     * @param tChangeTask 实例对象
     * @return 影响行数
     */
    int update(TChangeTask tChangeTask);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    List<TChangeTaskOut> selectByCid(@Param("id")Integer id, @Param("splitStatus")Integer splitStatus);

    /**
     *
     * @param tid 变更项目id
     * @param sid 变更拆分父项目id
     * @param type 处理类型
     * @return
     */
    int updateByTid(@Param("tid")Integer tid,@Param("sid")Integer sid,@Param("cid")Integer cid,@Param("type")Integer type,@Param("member") Integer member);



    int deleteByTid(Integer tid);


    TChangeTask selectBytid(Integer id);

    void updateMemberByTid( @Param("sid")Integer sid,@Param("cid")Integer cid, @Param("type")Integer type, @Param("serviceLife")String serviceLife,
                            @Param("serviceYear")String serviceYear, @Param("yearSum")Integer yearSum, @Param("contractTerm")String contractTerm);

    List<TChangeTask> selectBySuper(@Param("splitSuper") Integer splitSuper, @Param("changeSplitSuper") Integer changeSplitSuper, @Param("cid") Integer cid);

    void updateTypeBatch(@Param("type") Integer type, @Param("list") List<Integer> list);




    void deleteByChangeSplitSuper(Integer tid);

    void updateSuperServiceYear(TChangeTask tChangeTask);

    void updateChangeSuperServiceYear(TChangeTask tChangeTask);



    void insertSelective(TChangeTask t);

    TChangeTask selectByChageSplitSuper(Integer changeSplitSuper);
}


